var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                      .getService(Components.interfaces.nsIPrefBranch);

var FileAuction_Version = "0.4";
//@line 5 "/Users/weongyo/Developments/fileauction/src/chrome/content/global.js"

var MainHost = "http://www.fatalbid.com";

var URL_add	 = MainHost + "/fa/add.php";
var URL_ads	 = MainHost + "/fa/ads.php";
var URL_bid	 = MainHost + "/fa/bid.php";
var URL_category = MainHost + "/fa/category.php";
var URL_changetype = MainHost + "/fa/changetype.php";
var URL_deposit  = MainHost + "/fa/deposit.php";
var URL_getBid	 = MainHost + "/fa/get_bid.php";
var URL_getAuction = MainHost + "/fa/get_auction.php";
var URL_latest	 = MainHost + "/fa/latest.php";
var URL_login	 = MainHost + "/fa/login.php";
var URL_logout	 = MainHost + "/fa/logout.php";
var URL_money	 = MainHost + "/fa/money.php";
var URL_search	 = MainHost + "/fa/search.php";
var URL_cancelauction  = MainHost + "/fa/cancelauction.php";
var URL_newaccount     = MainHost + "/fa/account/step1.html";
var URL_forgotpassword = MainHost + "/fa/account/forgot/";
var URL_upload = MainHost + "/fa/upload.php";

var URL_attget   = MainHost + "/fa/mail/attget.php";
var URL_getpath	 = MainHost + "/fa/mail/getpath.php";
var URL_inbox	 = MainHost + "/fa/mail/inbox.php";
var URL_mark	 = MainHost + "/fa/mail/mark.php";
var URL_readmail = MainHost + "/fa/mail/read.php";
var URL_delmail  = MainHost + "/fa/mail/del.php";
var URL_sendmail = MainHost + "/fa/mail/sendmail.php";
var URL_savepaymoney = MainHost + "/fa/mail/savepaymoney.php";
var URL_signal   = MainHost + "/fa/mail/signal.php";

var URL_currency_dollar = "chrome://fa/skin/currency/dollar.png";
var URL_currency_won = "chrome://fa/skin/currency/won.png";
var URL_currency_yen = "chrome://fa/skin/currency/yen.png";
var URL_currency_euro = "chrome://fa/skin/currency/euro.png";
var URL_currency_cent = "chrome://fa/skin/currency/cent.png";

function initPrefs ()
{
  prefs.setBoolPref ("fileauction.login.status", false);
  prefs.setBoolPref ("fileauction.login.cancel", false);
  prefs.setBoolPref ("fileauction.money.init", false);
  prefs.setIntPref  ("fileauction.preferences.server.listening_port", 4390);
  prefs.setCharPref ("fileauction.currency.current", 'USD');
}

function uninitPrefs ()
{
  initPrefs ();
}

function checkLoginStatus ()
{
  if (!prefs.prefHasUserValue ("fileauction.login.status"))
    return false;

  var LoginStatus = prefs.getBoolPref ("fileauction.login.status");

  if (LoginStatus)
    return true;

  return false;
}

function openLoginDialog (tryNumber, withErrorMsg)
{
  /* do login. */
  window.openDialog ('chrome://fa/content/login.xul', 'login', 'chrome,modal,centerscreen', tryNumber, window);

  if (checkLoginStatus ())
    return true;

  return false;
}

function checkLogin (tryNumber, withErrorMsg)
{
  if (!checkLoginStatus ())
    return openLoginDialog (tryNumber, withErrorMsg);

  return true;
}

function checkTimesLogin ()
{
  var i;

  for (i=0; i<3; i++)
    {
      var withErrorMsg = false;
      var cancel = prefs.getBoolPref ("fileauction.login.cancel");

      if (cancel)
	{
	  prefs.setBoolPref ("fileauction.login.cancel", false);
	  return true;
	}
      
      if (i > 0)
	withErrorMsg = true;

      checkLogin (i, withErrorMsg);
    }

  return true;
}

function getRemainMoney ()
{
  var i = prefs.getBoolPref ("fileauction.money.init");

  if (i)
    {
      if (prefs.prefHasUserValue ("fileauction.money.current"))
	return prefs.getCharPref ("fileauction.money.current");
      else 
	alert ("getRemainMoney: error?");
    }

  var req = new XMLHttpRequest ();
  req.open ("GET", URL_money, false);
  req.send (null);
  
  if (req.readyState == 4 && req.status == 200)
    {
      if (!(req.responseText.charAt (0) == 'u'
	    || req.responseText.charAt (0) == 'e'))
	{
	  prefs.setBoolPref ("fileauction.money.init", true);
	  prefs.setCharPref ("fileauction.money.current", req.responseText.substring (2));

	  if (req.responseText.charAt (0) == '$')
	    prefs.setCharPref ("fileauction.money.user.currency", "USD");
	  else if (req.responseText.charAt (0) == '\\')
	    prefs.setCharPref ("fileauction.money.user.currency", "WON");
	  else
	    return "TODO";
	}

      return req.responseText.substring (2);
    }

  return "error";
}

function getCurrencyStrFromURL (url)
{
  if (url == URL_currency_dollar)
    return "USD";
  else if (url == URL_currency_euro)
    return "EUR";
  else if (url == URL_currency_won)
    return "WON";
  else if (url == URL_currency_yen)
    return "YEN";
  else
    return "error";
}

function getCurrencyTextFromStr (str)
{
  if (str == "USD")
    return "$";
  else if (str == "EUR")
    return "€";
  else if (str == "WON")
    return "₩";
  else if (str == "YEN")
    return "¥";
  else
    return "error";
}

function getCurrencyURLFromStr (str)
{
  if (str == "USD")
    return URL_currency_dollar;
  else if (str == "EUR")
    return URL_currency_euro;
  else if (str == "WON")
    return URL_currency_won;
  else if (str == "YEN")
    return URL_currency_yen;
  else
    return "error";
}

function commaFormat (num , sep) 
{ 
  var n = '' + num;
  var numl  = n.length;
  var i = n.indexOf ('.');
  var fract = '';
  
  if (i > -1)
    {
      numl -= n.length-i;
      fract = n.substring (i);
    }
  if (numl > 3)
    {
      var s, dl = numl%3;
      var str = (dl > 0) ? n.substring(0,dl):'';
      var max = Math.floor (numl/3);
      for (i=0 ; i < max ; i++)
	{
	  s = n.substring (dl + i * 3, dl + i * 3 + 3);
	  str += (dl==0 && i==0) ? s : sep+s;
	}
      return str+fract;
    }
  else
    return n;
}

function saveCurrentCurrency (c)
{
  prefs.setCharPref ("fileauction.currency.current", c);
}
