
function enableSendMailButtons ()
{
  var e = document.getElementById ("content-frame");
  e.makeEditable ('text', false);

  e = document.getElementById ("SendMailButton");
  e.disabled = false;
}

function setTotalRemainMoneyLabel ()
{
  var rs = getRemainMoney ();
  var lb = document.getElementById ("TotalRemainMoney");

  var s = prefs.getCharPref ("fileauction.money.user.currency");
  var l = document.getElementById ("TotalRemainMoneyImage");

  if (s == "USD")
    l.src = "chrome://fa/skin/currency/dollar.png";
  else if (s == "WON")
    l.src = "chrome://fa/skin/currency/won.png";
  else if (s == "YEN")
    l.src = "chrome://fa/skin/currency/yen.png";
  else if (s == "EUR")
    l.src = "chrome://fa/skin/currency/euro.png";
  
  lb.value = rs;
  lb.disabled = false;
}

function setMailTo ()
{
  var e;
  var to = "";
  var subject = "";

  if (prefs.prefHasUserValue ("fileauction.mail.to"))
    to = prefs.getCharPref ("fileauction.mail.to");
  if (prefs.prefHasUserValue ("fileauction.mail.subject"))
    subject = prefs.getCharPref ("fileauction.mail.subject");

  if (to != "")
    {
      prefs.setCharPref ("fileauction.mail.to", "");

      document.getElementById ("addressCol2").value = to;

      e = document.getElementById ("msgSubject");
      e.focus ();
    }
  else
    {
      e = document.getElementById ("addressCol2");
      e.focus ();
    }
  if (subject != "")
    {
      prefs.setCharPref ("fileauction.mail.subject", "");
      document.getElementById ("msgSubject").value = "Re: " + subject;
    }
}

function onLoadSendMail ()
{
  if (!checkTimesLogin ())
    return -1;

  if (!checkLoginStatus ())
    {
      s = document.getElementById ("SignUpFirst");
      s.hidden = false;
      s = document.getElementById ("SendMailBody");
      s.hidden = true;
      return 0;
    }
  
  setMailTo ();
  enableSendMailButtons ();
  setTotalRemainMoneyLabel ();

  if (prefs.prefHasUserValue ("fileauction.money.user.currency"))
    changeBottomMenuCurrency (prefs.getCharPref ("fileauction.money.user.currency"));

  return 0;
}

function serverSendmail ()
{
  var sendmailStrings = document.getElementById ("sendmailStrings");

  alert (sendmailStrings.getString ("servererror"));
}

function errorSendmail ()
{
  var sendmailStrings = document.getElementById ("sendmailStrings");
  
  alert (sendmailStrings.getString ("failedtosend"));
}

function refreshSendmailAttachments ()
{
  var j;
  var aw = document.getElementById ("attachmentWidget");

  for (j=0; j<aw.childNodes.length; j++)
    {
      if (aw.childNodes[j].tagName == "listitem")
	{
	  aw.removeChild (aw.childNodes[j]);
	  j = 0;
	}
    }
}

function refreshSendmail ()
{
  var i;
  var to = document.getElementById ("addressCol2");
  var subject = document.getElementById ("msgSubject");
  var body = document.getElementById ("content-frame");
  var currency = document.getElementById ("currencyAmountToSend");
  var money = document.getElementById ("inputAmountToSend");
  var radioDeliveryMethod = document.getElementById ("radioDeliveryMethod");
  var aw = document.getElementById ("attachmentWidget");
  var count = aw.getAttribute ("F_count");

  to.value = '';
  subject.value = '';
  body.contentDocument.body.innerHTML = '';
  money.value = '0';

  aw.setAttribute ("F_count", 0);
  for (i=1; i<count+1; i++)
    {
      aw.setAttribute ("F" + i + "_TransWay", '');
      aw.setAttribute ("F" + i + "_Name", '');
      aw.setAttribute ("F" + i + "_Path", '');
      aw.setAttribute ("F" + i + "_FileSize", 0);
      aw.setAttribute ("F" + i + "_Hash", 0);
    }

  for (j=0; j<aw.childNodes.length; j++)
    {
      if (aw.childNodes[j].tagName == "listitem")
	{
	  aw.removeChild (aw.childNodes[j]);
	  j = 0;
	}
    }
}


function sendmail ()
{
  var shouldRedirectToUpload = false;
  var qstr = "";
  var sendmailStrings = document.getElementById ("sendmailStrings");
  var to = document.getElementById ("addressCol2");
  var subject = document.getElementById ("msgSubject");
  var body = document.getElementById ("content-frame");
  var currency = document.getElementById ("currencyAmountToSend");
  var money = document.getElementById ("inputAmountToSend");
  var radioDeliveryMethod = document.getElementById ("radioDeliveryMethod");

  var cmsg = to.value 
    + " 님에게 돈 " 
    + getCurrencyTextFromStr (currency.getAttribute ("symbol"))
    + " "
    + money.value
    + "을 보내시겠습니까?";
  if (radioDeliveryMethod.selectedIndex == 0 
      && (money.value * 1) > 0
      && !confirm (cmsg))
    return;

  //to.value
  //subject.value
  //body.contentDocument.body.innerHTML

  //currency.label
  //money.value
  //radioDeliveryMethod.selectedIndex

  var aw = document.getElementById ("attachmentWidget");
  var count = aw.getAttribute ("F_count");
  count = count * 1;
  
  var s = subject.value;
  s = s.replace (/&/g, "%26");
  var b = body.contentDocument.body.innerHTML;
  b = b.replace (/&/g, "%26");

  qstr= "t=" + to.value
    +  "&s=" + s
    +  "&b=" + b
    +  "&c=" + currency.getAttribute ("symbol")
    +  "&m=" + money.value
    +  "&d=" + radioDeliveryMethod.selectedIndex;

  var fstr = "";
  var pstr = "";
  var i;

  for (i=1; i<count+1; i++)
    {
      var transway = aw.getAttribute ("F" + i + "_TransWay");
      var name = aw.getAttribute ("F" + i + "_Name");

      if (name == "")
	break;

      fstr = "&f" + i + "[]=" + aw.getAttribute ("F" + i + "_Name").replace (/&/g, "%26")
  	   + "&f" + i + "[]=" + aw.getAttribute ("F" + i + "_Path").replace (/&/g, "%26")
	   + "&f" + i + "[]=" + aw.getAttribute ("F" + i + "_FileSize")
	   + "&f" + i + "[]=" + aw.getAttribute ("F" + i + "_Hash")
           + "&f" + i + "[]=" + transway;

      if (transway == "Proxy" || transway == "Cached")
        shouldRedirectToUpload = true;

      qstr += fstr;
      pstr += fstr;
    }

  var req = new XMLHttpRequest ();
  req.open ("POST", URL_sendmail, false);
  req.setRequestHeader ('Content-Type', 'application/x-www-form-urlencoded');
  req.send (qstr);

  if (req.readyState == 4 && req.status == 200)
    {
      /* add succeed == 1
         add failure == 0 */
      if (!fa_error (req.responseText))
	{
	  prefs.setBoolPref ("fileauction.money.init", false);
	  fa_showMsg ("메일 발송",sendmailStrings.getString ("sendmailok"));
	  setTotalRemainMoneyLabel ();
	  refreshSendmail ();
          if (shouldRedirectToUpload)
            setTimeout ("openUploads (\"" + pstr + "\")", 1000);
	}
      else
	errorSendmail ();
    }
  else
    serverError ();
}

function openUploads (pstr)
{
  window.parent.paneBody.location.href = "http://file.fatalbid.com/?m=f" + pstr;
}

function changeBottomMenuCurrency (s)
{
  var l = document.getElementById ("currencyAmountToSend");
  
  if (s == "USD")
    l.src = "chrome://fa/skin/currency/dollar.png";
  else if (s == "WON")
    l.src = "chrome://fa/skin/currency/won.png";
  else if (s == "YEN")
    l.src = "chrome://fa/skin/currency/yen.png";
  else if (s == "EUR")
    l.src = "chrome://fa/skin/currency/euro.png";

  l.setAttribute ("symbol", s);
  saveCurrentCurrency (s);
}

function changeSendMoneyLabel (st)
{
  var l = document.getElementById ("smSendMoneyLabel");

  if (st == 0)
    l.value = "보낼 돈:";
  else if (st == 1)
    l.value = "지급해야 할 돈:";
  else
    l.value = "Error";
}

function updateTransferMethod (b)
{
  var l = document.getElementById ("attachmentWidget");
  var i = l.selectedIndex;

  if (i == -1)
    return;

  var n = l.getItemAtIndex (i).childNodes[0].childNodes[0].value;
  if (n == "Direct")
    document.getElementById ("TransDirect").setAttribute ("checked", true);
  else if (n == "Proxy")
    document.getElementById ("TransProxy").setAttribute ("checked", true);
  else if (n == "Cached")
    document.getElementById ("TransCached").setAttribute ("checked", true);
}

function setTransferMethod (idx)
{
  var l = document.getElementById ("attachmentWidget");
  var i = l.selectedIndex;

  if (i == -1)
    return;
  if (l.getAttribute("F_count") == "0")
    return;

  var n = l.getItemAtIndex (i).childNodes[0].childNodes[0];

  if (idx == 0)
    {
      l.setAttribute ("F" + (i+1) + "_TransWay", 'Direct');
      n.value = 'Direct';
      prefs.setCharPref ("fileauction.mail.defaultTransWay", "Direct");
    }
  else if (idx == 1)
    {
      l.setAttribute ("F" + (i+1) + "_TransWay", 'Proxy');
      n.value = 'Proxy';
      prefs.setCharPref ("fileauction.mail.defaultTransWay", "Proxy");
    }
  else if (idx == 2)
    {
      l.setAttribute ("F" + (i+1) + "_TransWay", 'Cached');
      n.value = 'Cached';
      prefs.setCharPref ("fileauction.mail.defaultTransWay", "Cached");
    }
}
