var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                      .getService(Components.interfaces.nsIPrefBranch);

function refreshAuctionsTree ()
{
  if (checkLoginStatus ())
    {
      var t = document.getElementById ("itemListTree");
      
      t.datasources = "";
      t.datasources = URL_getAuction;
    }
}

function setTotalRemainMoneyLabel ()
{
  var rs = getRemainMoney ();
  var lb = document.getElementById ("TotalRemainMoney");

  var s = prefs.getCharPref ("fileauction.money.user.currency");
  var l = document.getElementById ("TotalRemainMoneyImage");

  if (s == "USD")
    l.src = "chrome://fa/skin/currency/dollar.png";
  else if (s == "WON")
    l.src = "chrome://fa/skin/currency/won.png";
  else if (s == "YEN")
    l.src = "chrome://fa/skin/currency/yen.png";
  else if (s == "EUR")
    l.src = "chrome://fa/skin/currency/euro.png";
  
  lb.value = rs;

  saveCurrentCurrency (s);
}

function enableAuctionsButton ()
{
  var i;
  
  i= document.getElementById ("CancelAuctionButton");
  i.disabled = false;
  i= document.getElementById ("CreateAuctionButton");
  i.disabled = false;
  i= document.getElementById ("inputSubject");
  i.disabled = false;
  i= document.getElementById ("inputDescription");
  i.disabled = false;
  i= document.getElementById ("currencyStartingPrice");
  i.disabled = false;
  i= document.getElementById ("currencyBuyoutPrice");
  i.disabled = false;
  i= document.getElementById ("inputStartingPrice");
  i.disabled = false;
  i= document.getElementById ("inputBuyoutPrice");
  i.disabled = false;
  i= document.getElementById ("DepositText");
  i.disabled = false;
  i= document.getElementById ("Deposit");
  i.disabled = false;
  i= document.getElementById ("AuctionDuration_2H");
  i.disabled = false;
  i= document.getElementById ("AuctionDuration_8H");
  i.disabled = false;
  i= document.getElementById ("AuctionDuration_24H");
  i.disabled = false;
  i= document.getElementById ("TotalRemainMoney");
  i.disabled = false;
}

function initAuctions ()
{
  if (!checkTimesLogin ())
    return -1;

  if (!checkLoginStatus ())
    {
      s = document.getElementById ("SignUpFirst");
      s.hidden = false;
      s = document.getElementById ("AuctionsBody");
      s.hidden = true;
      return 0;
    }

  setTotalRemainMoneyLabel ();
  if (prefs.prefHasUserValue ("fileauction.currency.current"))
    {
      var c = prefs.getCharPref ("fileauction.currency.current");
      changeBottomMenuCurrency (c);
    }
  else
    changeBottomMenuCurrency ('USD');

  refreshAuctionsTree ();
  enableAuctionsButton ();

  return 0;
}

function serverError ()
{
  var auctionsStrings = document.getElementById ("auctionsStrings");

  alert (auctionsStrings.getString ("servererror"));
}

function errorAuctions ()
{
  var auctionsStrings = document.getElementById ("auctionsStrings");

  alert (auctionsStrings.getString ("errorauction"));
}

function refreshAuctions ()
{
  var auctionsStrings = document.getElementById ("auctionsStrings");

  var f = document.getElementById ("auctionItemFileName");
  f.value = auctionsStrings.getString ("draganddrop");
  f.disabled = true;

  getthetree().DeleteAll ();

  var subject = document.getElementById ("inputSubject");
  subject.value = "";
  var description = document.getElementById ("inputDescription");
  description.value = "";

  var startingprice = document.getElementById ("inputStartingPrice");
  startingprice.value = "0";
  var buyoutprice = document.getElementById ("inputBuyoutPrice");
  buyoutprice.value = "0";

  var fileinfo = document.getElementById ("auctionItemFileName");
  fileinfo.setAttribute ("FI_Name", "");
  fileinfo.setAttribute ("FI_Path", "");
  fileinfo.setAttribute ("FI_FileSize", "");
  fileinfo.setAttribute ("FI_Hash", "");

  refreshAuctionsTree ();
}

function summitAuctions ()
{
  var qstr = "";

  var subject = document.getElementById ("inputSubject");
  //subject.value
  var description = document.getElementById ("inputDescription");
  //description.value

  var startingprice = document.getElementById ("inputStartingPrice");
  //startingprice.value
  var buyoutprice = document.getElementById ("inputBuyoutPrice");
  //buyoutprice.value
  var radioAuctionDuration = document.getElementById ("radioAuctionDuration");
  //radioAuctionDuration.selectedIndex

  var fileinfo = document.getElementById ("auctionItemFileName");
  //fileinfo.getAttribute ("FI_Name")
  //fileinfo.getAttribute ("FI_Path")
  //fileinfo.getAttribute ("FI_FileSize")
  //fileinfo.getAttribute ("FI_Hash")

  var s = subject.value;
  s = s.replace (/&/g, "%26");
  var d = description.value;
  d = d.replace (/&/g, "%26");
  var fn = fileinfo.getAttribute ("FI_Name");
  fn = fn.replace (/&/g, "%26");
  var fp = fileinfo.getAttribute ("FI_Path");
  fp = fp.replace (/&/g, "%26");

  qstr= "s=" + s
    +  "&d=" + d
    + "&ps=" + startingprice.value
    + "&pb=" + buyoutprice.value
    +  "&c=" + prefs.getCharPref ("fileauction.currency.current")
    +  "&r=" + radioAuctionDuration.selectedIndex
    + "&fn=" + fn
    + "&fp=" + fp
    + "&fs=" + fileinfo.getAttribute ("FI_FileSize")
    + "&fh=" + fileinfo.getAttribute ("FI_Hash");

  var req = new XMLHttpRequest ();
  req.open ("POST", URL_add, false);
  req.setRequestHeader ('Content-Type', 'application/x-www-form-urlencoded');
  req.send (qstr);

  if (req.readyState == 4 && req.status == 200)
    {
      /* add succeed == 1
         add failure == 0 */
      if (!fa_error (req.responseText))
	{
          fa_showMsgNoAlert ("경매", "물품 등록이 완료하였습니다.");
	  prefs.setBoolPref ("fileauction.money.init", false);
	  setTotalRemainMoneyLabel ();
	  refreshAuctions ();
	}
    }
  else
    serverError ();
}

function changeDeposit (c)
{
  var depositURL = URL_deposit + "?c=" + c;

  var req = new XMLHttpRequest ();
  req.open ("GET", depositURL, false);
  req.send (null);

  if (req.readyState == 4 && req.status == 200)
    {
      var dp = document.getElementById ("Deposit");

      var s =  req.responseText.charAt (0);
      var l = document.getElementById ("DepositImage");
      if (s == "$")
	l.src = "chrome://fa/skin/currency/dollar.png";
      else if (s == "\\")
	l.src = "chrome://fa/skin/currency/won.png";
      else if (s == "%")
	l.src = "chrome://fa/skin/currency/euro.png";

      dp.value = req.responseText.substring (2);
    }
}

function changeBottomMenuCurrency (s)
{
  var sp = document.getElementById ("currencyStartingPrice");
  var bp = document.getElementById ("currencyBuyoutPrice");
  
  if (s == "USD")
    {
      sp.src = "chrome://fa/skin/currency/dollar.png";
      bp.src = "chrome://fa/skin/currency/dollar.png";
    }
  else if (s == "WON")
    {
      sp.src = "chrome://fa/skin/currency/won.png";
      bp.src = "chrome://fa/skin/currency/won.png";
    }
  else if (s == "YEN")
    {
      sp.src = "chrome://fa/skin/currency/yen.png";
      bp.src = "chrome://fa/skin/currency/yen.png";
    }
  else if (s == "EUR")
    {
      sp.src = "chrome://fa/skin/currency/euro.png";
      bp.src = "chrome://fa/skin/currency/euro.png";
    }

  sp.setAttribute ("symbol", s);
  bp.setAttribute ("symbol", s);

  changeDeposit (s);
  saveCurrentCurrency (s);
}

function AuctionsCancelAuction ()
{
  var auctionsStrings = document.getElementById ("auctionsStrings");
  var t = document.getElementById ("itemListTree");

  if (t.currentIndex == -1)
    {
      alert ("경매 취소할 물품을 선택하세요.");
      return;
    }

  var uid = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("BidsColumnUID"));

  qstr = "u=" + uid;

  var req = new XMLHttpRequest ();
  req.open ("POST", URL_cancelauction, false);
  req.setRequestHeader ('Content-Type', 'application/x-www-form-urlencoded');
  req.send (qstr);

  if (req.readyState == 4 && req.status == 200)
    {
      if (!fa_error (req.responseText))
	{
	  try {
	    refreshAuctionsTree ();
	    fa_showMsg ("경매 취소", auctionsStrings.getString ("cancel"));
	  } catch (e) { alert (e); }
	}
    }
}

function setTransferMethod (type)
{
  var auctionsStrings = document.getElementById ("auctionsStrings");
  var t = document.getElementById ("itemListTree");

  if (t.currentIndex == -1)
    return;

  var typeMsg = '';
  if (type == 0)
    typeMsg = '직접 전송 방식';
  else if (type == 1)
    typeMsg = 'Proxy 전송 방식';
  else if (type == 2)
    typeMsg = 'Cached 전송 방식';

  if (!confirm ("물품 전송 방식을 정말 '" + typeMsg +"'으로 변경하시겠습니까?\n\n변경 후 다시 변경할 수 없습니다."))
    return;

  var uid = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("BidsColumnUID"));

  qstr = "u=" + uid
    + "&t=" + type;

  var req = new XMLHttpRequest ();
  req.open ("POST", URL_changetype, false);
  req.setRequestHeader ('Content-Type', 'application/x-www-form-urlencoded');
  req.send (qstr);

  if (req.readyState == 4 && req.status == 200)
    {
      if (!fa_error (req.responseText))
	{
	  try {
	    refreshAuctionsTree ();
	    if (type == 1 || type == 2)
              {
                setTimeout ("openUploads (" + type + ")", 1000);
              }
	  } catch (e) { alert (e); }
	}
    }
}

function openUploads (type)
{
  window.parent.paneBody.location.href = "http://file.fatalbid.com/?w=" + type;
}

function updateTransferMethod (b)
{
  var auctionsStrings = document.getElementById ("auctionsStrings");
  var t = document.getElementById ("itemListTree");

  if (t.currentIndex == -1)
    return;

  var mth = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("ID_ItemListTreeTrasMethod"));
  
  if (mth == "Direct")
    document.getElementById ("TransDirect").setAttribute ("checked", true);
  else if (mth == "Proxy")
    document.getElementById ("TransProxy").setAttribute ("checked", true);
  else if (mth == "Cached")
    document.getElementById ("TransCached").setAttribute ("checked", true);
}

function copyRarityInfoToClipboard (cType)
{
  var auctionsStrings = document.getElementById ("auctionsStrings");
  var t = document.getElementById ("itemListTree");

  if (t.currentIndex == -1)
    return;

  var uid = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("BidsColumnUID"));
  var subject = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("ID_ItemListTreeRarity"));

  if (cType == 0)
    var info = 'http://www.fatalbid.com/fa/items.php/' + uid;
  else if (cType == 1)
    var info = 'http://www.fatalbid.com/fa/itemimage.php/uid/' + uid;
  else if (cType == 2)
    {
      var info = '<a href="http://www.fatalbid.com/fa/items.php/' 
        + uid
        + '"><img src="http://www.fatalbid.com/fa/itemimage.php/uid/' 
        + uid
        + '.png" border="0" alt="' 
        + subject + '"/></a>';
    }
  else if (cType == 3)
    {
      var info = '[url=http://www.fatalbid.com/fa/items.php/' + uid + '] [img]http://www.fatalbid.com/fa/itemimage.php/uid/' + uid + '.png[/img] [/url]';
    }

  const gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
                                     .getService(Components.interfaces.nsIClipboardHelper);
  gClipboardHelper.copyString (info);

  fa_showMsg ("물품 주소", "주소가 복사되었습니다.");
}

function openAdPage ()
{
  var auctionsStrings = document.getElementById ("auctionsStrings");
  var t = document.getElementById ("itemListTree");

  if (t.currentIndex == -1)
    return;

  var uid = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("BidsColumnUID"));

  window.parent.paneBody.location.href = "http://www.fatalbid.com/fa/itemad.php?id=" + uid;
}
