
function setTotalRemainMoneyLabel ()
{
  var rs = getRemainMoney ();
  var lb = document.getElementById ("TotalRemainMoney");

  var s = prefs.getCharPref ("fileauction.money.user.currency");
  var l = document.getElementById ("TotalRemainMoneyImage");

  if (s == "USD")
    l.src = "chrome://fa/skin/currency/dollar.png";
  else if (s == "WON")
    l.src = "chrome://fa/skin/currency/won.png";
  else if (s == "YEN")
    l.src = "chrome://fa/skin/currency/yen.png";
  else if (s == "EUR")
    l.src = "chrome://fa/skin/currency/euro.png";
  
  lb.value = rs;
  saveCurrentCurrency (s);
}

function enableBidBuyoutButton ()
{
  var i;

  i= document.getElementById ("tryBidButton");
  i.disabled = false;
  i= document.getElementById ("tryBuyoutButton");
  i.disabled = false;
  i= document.getElementById ("TotalRemainMoney");
  i.disabled = false;
  i= document.getElementById ("BidText");
  i.disabled = false;
  i= document.getElementById ("inputNewBid");
  i.disabled = false;
  i.value = "0";
}

function refreshBidsTree ()
{
  if (checkLoginStatus ())
    {
      var t = document.getElementById ("itemListTree");
      
      t.datasources = "";
      t.datasources = URL_getBid;
    }
}

function initBids ()
{
  var s;

  if (!checkTimesLogin ())
    return -1;

  if (!checkLoginStatus ())
    {
      s = document.getElementById ("SignUpFirst");
      s.hidden = false;
      s = document.getElementById ("bidsItemListTree");
      s.hidden = true;
      return 0;
    }
  
  setTotalRemainMoneyLabel ();
  enableBidBuyoutButton ();
  if (prefs.prefHasUserValue ("fileauction.money.user.currency"))
    changeBottomMenuCurrency (prefs.getCharPref ("fileauction.money.user.currency"));
  refreshBidsTree ();

  return 0;
}

function changeBottomMenuCurrency (s)
{
  var l = document.getElementById ("CurrencyImage");
  
  if (s == "USD")
    l.src = "chrome://fa/skin/currency/dollar.png";
  else if (s == "WON")
    l.src = "chrome://fa/skin/currency/won.png";
  else if (s == "YEN")
    l.src = "chrome://fa/skin/currency/yen.png";
  else if (s == "EUR")
    l.src = "chrome://fa/skin/currency/euro.png";

  l.setAttribute ("symbol", s);
  saveCurrentCurrency (s);
}

function BidsBidSelectedItem (is_buyout)
{
  var bidsStrings = document.getElementById ("bidsStrings");
  var c = document.getElementById ("CurrencyImage");
  var t = document.getElementById ("itemListTree");

  if (t.currentIndex == -1)
    return;

  var co = t.treeBoxObject.view.getItemAtIndex (t.currentIndex);
  var uid = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("BidsColumnUID"));
  var cu = t.treeBoxObject.view.getImageSrc (t.currentIndex, t.columns.getNamedColumn ("BidsColumnCurrentBid"));

  var v = document.getElementById ("inputNewBid");

  if (c.getAttribute ("symbol") != getCurrencyStrFromURL (cu))
    {
      alert (bidsStrings.getString ("incorrentcurrency"));
      return;
    }

  price = v.value * 1;
  if (is_buyout)
    {
      var bp = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("BidsColumnBuyoutPrice"));
      price = bp * 1;
    }
    
  qstr =    "c=" + c.getAttribute ("symbol")
         + "&v=" + price
         + "&i=" + uid;

  var req = new XMLHttpRequest ();
  req.open ("POST", URL_bid, false);
  req.setRequestHeader ('Content-Type', 'application/x-www-form-urlencoded');
  req.send (qstr);

  if (req.readyState == 4 && req.status == 200)
    {
      if (!fa_error (req.responseText))
	{
	  prefs.setBoolPref ("fileauction.money.init", false);
	  setTotalRemainMoneyLabel ();

	  try {
	    if (is_buyout)
	      fa_showMsg ("물품 즉시구매", bidsStrings.getString ("buyoutok"));
	    else
	      fa_showMsg ("물품 입찰", bidsStrings.getString ("bidok"));
	    refreshBidsTree ();
	  } catch (e) { alert (e); }
	}
    }
}

function selectItemListTree ()
{
  if (!checkLoginStatus ())
    return;

  var t = document.getElementById ("itemListTree");

  if (t.currentIndex == -1)
    return;

  var co = t.treeBoxObject.view.getItemAtIndex (t.currentIndex);
  var cl = t.treeBoxObject.view.getCellText (t.currentIndex, t.columns.getNamedColumn ("BidsColumnCurrentBid"));

  var i = document.getElementById ("inputNewBid");
  i.value = cl;
}

function openSendMailTo ()
{
  var t = document.getElementById ("itemListTree");
  
  if (t.currentIndex == -1)
    {
      alert ("아이템을 선택하지 않았습니다.");
      return;
    }

  var seller = t.treeBoxObject.view.getCellText (t.currentIndex, 
						 t.columns.getNamedColumn ("ID_ItemListTreeSeller"));

  prefs.setCharPref ("fileauction.mail.to", seller);
  window.parent.gFileAuctionWindow.menusSelectionChangedCore ("paneSendMail");
}
