var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                      .getService(Components.interfaces.nsIPrefBranch);

function initLoginDialog (event)
{
  var withErrorMsg = window.arguments[0];

  if (withErrorMsg)
    {
      var l = document.getElementById ("loginErrorMsg");
      l.hidden = false;
    }

  var id = document.getElementById ("username");
  id.focus ();
}

function uninitLoginDialog (event)
{
}

function doLogin ()
{
  var userid, passwd, remember;

  if (checkLoginStatus ())
    return true;

  userid = document.getElementById ("username");
  passwd = document.getElementById ("password");
  remember = document.getElementById ("rememberpasswd");

  if (remember.checked)
    remember = 1;
  else
    remember = 0;

  var qstr = "u=" + userid.value
          + "&p=" + passwd.value
          + "&r=" + remember
          + "&t=" + prefs.getIntPref ("fileauction.preferences.server.listening_port");

  var req = new XMLHttpRequest ();
  req.open ("POST", URL_login, false);
  req.setRequestHeader ('Content-Type', 'application/x-www-form-urlencoded');
  req.send (qstr);

  if (req.readyState == 4 && req.status == 200)
    {
      /* login succeed == 1
         login failure == 0 */
      if (req.responseText.charAt (0) == "1")
	{
	  prefs.setBoolPref ("fileauction.login.status", true);
	  prefs.setCharPref ("fileauction.login.userid", userid.value);
          fa_showMsgNoAlert ("로그인", "성공적으로 로그인하였습니다.");
	}
    }

  return true;
}

function cancelDialog ()
{
  prefs.setBoolPref ("fileauction.login.cancel", true);

  return true;
}

function loginCreateNewAccount ()
{
  var w =  window.arguments[1];
  var pd = window.parent;
  var b = document.getElementById ("loginErrorMsg");

  w.location.href = URL_newaccount + "?l=" + prefs.getCharPref ("general.useragent.locale");
  cancelDialog ();
  window.close ();
}

function loginForgotPassword ()
{
  var w =  window.arguments[1];
  var pd = window.parent;
  var b = document.getElementById ("loginErrorMsg");

  w.location.href = URL_forgotpassword;
  cancelDialog ();
  window.close ();
}
