pref("toolkit.defaultChromeURI", "chrome://fa/content/main.xul");
pref("toolkit.singletonWindowType", "FileAuction");

// preferences
pref("browser.preferences.animateFadeIn", false);
pref("browser.preferences.instantApply", true);

// suppress external-load warning for standard browser schemes
pref("network.protocol-handler.warn-external.https", false);

// locale
pref("general.useragent.locale", "ko-KR");

// help viewer
pref("accessibility.typeaheadfind.timeout", 5000);
pref("accessibility.typeaheadfind.flashBar", 0);

// download manager
pref("browser.download.folderList", 0);
pref("browser.download.manager.closeWhenDone", false);
pref("browser.download.manager.flashCount", 2);
pref("browser.download.manager.focusWhenStarting", false);
pref("browser.download.manager.openDelay", 0);
pref("browser.download.manager.retention", 2);
pref("browser.download.manager.showAlertInterval", 2000);
pref("browser.download.manager.showAlertOnComplete", true);
pref("browser.download.manager.showWhenStarting", true);
pref("browser.download.manager.useWindow", true);
pref("browser.download.show_plugins_in_list", true);
pref("browser.download.useDownloadDir", true);

// disable warning
pref("security.warn_entering_secure", false);
pref("security.warn_entering_weak", false);
pref("security.warn_leaving_secure", false);
pref("security.warn_submit_insecure", false);
pref("security.warn_viewing_mixed", false);

/* debugging prefs */
pref("browser.dom.window.dump.enabled", true);
pref("javascript.options.showInConsole", true);
pref("javascript.options.strict", true);
pref("nglayout.debug.disable_xul_cache", true);
pref("nglayout.debug.disable_xul_fastload", true);

pref("general.useragent.extra.firefox", "FileAuction");

